# -*- coding: utf-8 -*-
# Generated by Django 1.11.27 on 2020-01-29 19:44
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
from django.conf import settings

import archaeological_finds.models_treatments


class Migration(migrations.Migration):

    dependencies = [
        ('archaeological_finds', '0102_link_apps'),
    ]

    operations = [
        migrations.AddField(
            model_name='historicalbasefind',
            name='history_change_reason',
            field=models.CharField(max_length=100, null=True),
        ),
        migrations.AddField(
            model_name='historicalfind',
            name='history_change_reason',
            field=models.CharField(max_length=100, null=True),
        ),
        migrations.AddField(
            model_name='historicaltreatment',
            name='history_change_reason',
            field=models.CharField(max_length=100, null=True),
        ),
        migrations.AddField(
            model_name='historicaltreatmentfile',
            name='history_change_reason',
            field=models.CharField(max_length=100, null=True),
        ),
        migrations.AlterField(
            model_name='historicalbasefind',
            name='batch',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.BatchType',
                                    verbose_name='Batch/object'),
        ),
        migrations.AlterField(
            model_name='historicalbasefind',
            name='context_record',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_context_records.ContextRecord',
                                    verbose_name='Context Record'),
        ),
        migrations.AlterField(
            model_name='historicalbasefind',
            name='history_creator',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Creator'),
        ),
        migrations.AlterField(
            model_name='historicalbasefind',
            name='history_modifier',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Last editor'),
        ),
        migrations.AlterField(
            model_name='historicalbasefind',
            name='lock_user',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Locked by'),
        ),
        migrations.AlterField(
            model_name='historicalbasefind',
            name='spatial_reference_system',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='ishtar_common.SpatialReferenceSystem',
                                    verbose_name='Spatial Reference System'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='checked_type',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.CheckedType',
                                    verbose_name='Check'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='collection',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_warehouse.Collection',
                                    verbose_name='Collection'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='conservatory_state',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.ConservatoryState',
                                    verbose_name='Conservatory state'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='container',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_warehouse.Container',
                                    verbose_name='Container'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='container_ref',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_warehouse.Container',
                                    verbose_name='Reference container'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='downstream_treatment',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.Treatment',
                                    verbose_name='Downstream treatment'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='history_creator',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Creator'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='history_modifier',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Last editor'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='lock_user',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Locked by'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='main_image',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='ishtar_common.Document',
                                    verbose_name='Main image'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='material_type_quality',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.MaterialTypeQualityType',
                                    verbose_name='Material type quality'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='object_type_quality',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.ObjectTypeQualityType',
                                    verbose_name='Object type quality'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='treatment_emergency',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.TreatmentEmergencyType',
                                    verbose_name='Treatment emergency'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='upstream_treatment',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.Treatment',
                                    verbose_name='Upstream treatment'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='container',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_warehouse.Container',
                                    verbose_name='Container'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='file',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.TreatmentFile',
                                    verbose_name='Associated request'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='history_creator',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Creator'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='history_modifier',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Last editor'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='location',
            field=models.ForeignKey(blank=True, db_constraint=False,
                                    help_text='Location where the treatment is done. Target warehouse for a move.',
                                    null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_warehouse.Warehouse',
                                    verbose_name='Location'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='lock_user',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Locked by'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='main_image',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='ishtar_common.Document',
                                    verbose_name='Main image'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='organization',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='ishtar_common.Organization',
                                    verbose_name='Organization'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='person',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+', to='ishtar_common.Person',
                                    verbose_name='Responsible'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='scientific_monitoring_manager',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+', to='ishtar_common.Person',
                                    verbose_name='Scientific monitoring manager'),
        ),
        migrations.AlterField(
            model_name='historicaltreatment',
            name='treatment_state',
            field=models.ForeignKey(blank=True, db_constraint=False,
                                    default=archaeological_finds.models_treatments.TreatmentState.get_default,
                                    null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.TreatmentState',
                                    verbose_name='State'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='applicant',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+', to='ishtar_common.Person',
                                    verbose_name='Applicant'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='applicant_organisation',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='ishtar_common.Organization',
                                    verbose_name='Applicant organisation'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='history_creator',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Creator'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='history_modifier',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Last editor'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='in_charge',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+', to='ishtar_common.Person',
                                    verbose_name='Person in charge'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='lock_user',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to=settings.AUTH_USER_MODEL,
                                    verbose_name='Locked by'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='main_image',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='ishtar_common.Document',
                                    verbose_name='Main image'),
        ),
        migrations.AlterField(
            model_name='historicaltreatmentfile',
            name='type',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING,
                                    related_name='+',
                                    to='archaeological_finds.TreatmentFileType',
                                    verbose_name='Treatment request type'),
        ),
    ]
